/*
 * Pricing and Terms of Service
Pricing

Google Translate API v2 pricing is based on usage. Translation usage is calculated in millions of characters (M), where 1 M = 106 characters.

Important: Google Translate API v2 requires billing information for all accounts before you can start using the service. To sign up for billing, sign in to the Google APIs console and click the Billing tab.

    Usage fees:
        Translation:
            $20 per 1 M characters of text, where the charges are adjusted in proportion to the number of characters actually provided.
        Language Detection:
            $20 per 1 M characters of text, where the charges are adjusted in proportion to the number of characters actually provided.
    Usage limits:
        Google Translate API v2 has a default limit of 2M chars/day. This limit can be increased up to 50M chars/day in the Quotas pane in the Google APIs Console
        If you need to translate more than 50 M chars/day, please contact us

You can manage billing for Google Translate API v2 on the Billing pane in the Google APIs Console.
Terms of Service

You acknowledge that your use of the Google Translate API is governed by the Translate API terms of service and that you may not use the Translate API without accepting the Translate API terms of service. Google reserves the right to throttle excessive usage that might threaten the availability of our service. 
 */

package fi.cs;

import com.google.api.GoogleAPI;
import com.google.api.detect.Detect;
import com.google.api.detect.DetectResult;
import com.google.api.translate.Language;
import com.google.api.translate.Translate;

public class GoogleTranslator {
	public static String GOOGLE_API_KEY = "";

	public static void main(String[] args) throws Exception {

		// Translate.setHttpReferrer("http://translate.google.cn");
		// String translatedText =
		// Translate.execute("",Language.CHINESE_SIMPLIFIED,
		// Language.ENGLISH);
		// System.out.println(translatedText);
		// DetectResult detectResult=Detect.execute("you are good");
		// Language language=detectResult.getLanguage();

		GoogleTranslator googleTranslator = new GoogleTranslator();
		GoogleAPI.setHttpReferrer("http://translate.google.cn");
		GoogleAPI.setKey(GOOGLE_API_KEY);

		String text = "";

		// automatically language dector
		Language language = getDectLanguage(text);
		// translator
		String translateString = getTranslation("ʳƷ");
		System.out.println("The orginal language is: " + language.toString());
		System.out.println("The meaning of " + text + " in English is: "
				+ translateString);

	}

	// from any language to english
	public static String getTranslation(String text) throws Exception {
		GoogleAPI.setHttpReferrer("http://translate.google.cn");
		GoogleAPI.setKey(GOOGLE_API_KEY);
		Language LanguageFrom = GoogleTranslator.getDectLanguage(text);
		String translationString = Translate.DEFAULT.execute(text,
				LanguageFrom, Language.ENGLISH);
		return translationString;
	}

	// from finish to english
	public static String getTranslationByLanguage(String text, String language)
			throws Exception {
		GoogleAPI.setHttpReferrer("http://translate.google.cn");
		GoogleAPI.setKey(GOOGLE_API_KEY);
		String translationString = null;
		if (language.trim().equalsIgnoreCase("finish")) {
			translationString = Translate.DEFAULT.execute(text,
					Language.FINNISH, Language.ENGLISH);
		}

		return translationString;
	}

	// from finish to english
	public static String getTranslationFromEnglishToFinish(String text)
			throws Exception {
		GoogleAPI.setHttpReferrer("http://translate.google.com/#en|fi|");
		GoogleAPI.setKey(GOOGLE_API_KEY);
		String translationString = null;

		translationString = Translate.DEFAULT.execute(text, Language.ENGLISH,
				Language.FINNISH);

		return translationString;
	}

	public static String getTranslationFromFinishToEnglish(String text)
			throws Exception {
		GoogleAPI.setHttpReferrer("http://translate.google.com/#fi|en|");
		GoogleAPI.setKey(GOOGLE_API_KEY);
		String translationString = null;

		translationString = Translate.DEFAULT.execute(text, Language.FINNISH,
				Language.ENGLISH);

		return translationString;
	}

	// get the which language the text belong
	public static Language getDectLanguage(String text) throws Exception {
		DetectResult detectResult = Detect.execute(text);
		Language language = detectResult.getLanguage();
		return language;
	}
}
