package fi.cs;

import java.util.HashMap;
import java.io.*;
import java.net.URL;
import edu.sussex.nlp.jws.*;
import edu.mit.jwi.*;
import edu.mit.jwi.item.*;

public class WordnetSimilarity {
	
//	 String dir = "C:/Program Files/WordNet";
	
	File directory = new File("");
	String dir= directory.getAbsolutePath()+"/WordNet";
	
	 JWS ws = new JWS(dir, "3.0");
	 WuAndPalmer wup=ws.getWuAndPalmer();
	 JiangAndConrath jiang = ws.getJiangAndConrath();
	 
	 public double getWordnetSimilarity(String word1, String word2, String type,
				int method) throws IOException {
		double similarityValuetemp=0;	
		 double similarityValue=0;
			
			// 1 Jiang
			JiangAndConrath jiang = null;
			// 2 Wu			
			WuAndPalmer wu = null;
			// 3 Lin	
			Lin lin=null;
			// 4 Path
			Path path =null;
			
			String temp1;
			String temp2;

			if (method == 1) {
				// if one or two words do not exist in WordNet, return -1
				// Create a stream to hold the output
			    ByteArrayOutputStream baos = new ByteArrayOutputStream();
			    PrintStream ps = new PrintStream(baos);
			    // IMPORTANT: Save the old System.out!
			    PrintStream old = System.out;
			    // Tell Java to use your special stream
			    System.setOut(ps);
			    // Print some output: goes to your special stream
			    
				//////////////////////////////////////////////////////////////
				jiang = ws.getJiangAndConrath();
				similarityValuetemp = jiang.max(word1, word2, type);
				//////////////////////////////////////////////////////////////
				
				// Put things back on output console
			    System.out.flush();
			    System.setOut(old);
				
			    temp1 = baos.toString();
			    temp2 = "do not exist";
			    if ( temp1.contains(temp2) )
			    	similarityValuetemp = -1.0;
			
				return similarityValuetemp;

			} else if (method== 2) {
				wu=ws.getWuAndPalmer();
				similarityValuetemp = wu.max(word1, word2, type);
				
				return similarityValuetemp;
				
			} else if (method == 3) {
				lin = ws.getLin();
				similarityValuetemp = lin.max(word1, word2, type);
			
				return similarityValuetemp;
				
			} else if (method == 4) {
				path = ws.getPath();
				similarityValuetemp = path.max(word1, word2, type);
				
				return similarityValuetemp;
				
			}else {
				similarityValue=-1;
				return similarityValue;
			}

			// JiangAndConrath wup=ws.getJiangAndConrath();

			// TreeMap<String, Double> scores1 = jcn.jcn("apple", "banana", "n"); //
			// all

			// double similarityValue = wup.max(word1, word2, type);
			// double similarityValue = jinag.jcn(word1, 1, word2, 1, type);

		}

		
	// get the similarity by just comparing the first meaning of two words 
	public double getWordnetSimilarity(String word1, String word2,
			String type)throws IOException{
	

		
		//JiangAndConrath wup=ws.getJiangAndConrath();
		

		// TreeMap<String, Double> scores1 = jcn.jcn("apple", "banana", "n"); //
		// all
		
		//double similarityValue = wup.max(word1, word2, type);
	//	double similarityValue = wup.wup(word1, 1, word2, 1, type);
		double similarityValue = jiang.max(word1, word2, type);
		return similarityValue;
	}
	
	// get the similarity by just comparing the all the meaning of two words
	public double getWordnetSimilarityAll(String word1, String word2,
			String type) throws IOException {
	

		
		//JiangAndConrath wup=ws.getJiangAndConrath();
		

		// TreeMap<String, Double> scores1 = jcn.jcn("apple", "banana", "n"); //
		// all
		
		//double similarityValue = wup.max(word1, word2, type);
		double similarityValue = wup.max(word1,word2,type);
		return similarityValue;
	}
	
	/*get the similarity by just comparing the all the meaning of two words by five different measure
	 * 1. JiangAndConrath
	 * 2. Lin
	 * 3. Path
	 * 4. WuAndPalmer
	 */
	public double getWordnetSimilarityByMeasure(String word1, String word2,
			String type, String measure) throws IOException {
		
		
		if (measure.trim().equalsIgnoreCase("1")) {
			JiangAndConrath jiangAndConrath=ws.getJiangAndConrath();
			double similarityValue= jiangAndConrath.jcn(word1, 1, word2, 1, type);
			return similarityValue;
		} else if(measure.trim().equalsIgnoreCase("2")){
			Lin lin=ws.getLin();
			double similarityValue= lin.lin(word1, 1, word2, 1, type);
			return similarityValue;
		} else if(measure.trim().equalsIgnoreCase("3")){
			Path path=ws.getPath();
			double similarityValue= path.path(word1, 1, word2, 1, type);
			return similarityValue;	
		}else if(measure.trim().equalsIgnoreCase("4")){			
			double similarityValue= wup.wup(word1, 1, word2, 1, type);
			return similarityValue;
		}else{
			return 0;
		}
	}
	
	/*get the similarity by just comparing the first the meaning of two words by five different measure
	 * 1. JiangAndConrath
	 * 2. Lin
	 * 3. Path
	 * 4. WuAndPalmer
	 */
	public double getWordnetSimilarityAllByMeasure(String word1, String word2,
			String type, String measure) throws IOException {
		
		
		if (measure.trim().equalsIgnoreCase("1")) {
			JiangAndConrath jiangAndConrath=ws.getJiangAndConrath();
			double similarityValue= jiangAndConrath.max(word1, word2, type);
			return similarityValue;
		} else if(measure.trim().equalsIgnoreCase("2")){
			Lin lin=ws.getLin();
			double similarityValue= lin.max(word1, word2, type);
			return similarityValue;
		}else if(measure.trim().equalsIgnoreCase("3")){
			Path path=ws.getPath();
			double similarityValue= path.max(word1, word2, type);
			return similarityValue;
			
		}else if(measure.trim().equalsIgnoreCase("4")){
			
			double similarityValue= wup.max(word1, word2, type);
			return similarityValue;
		}else{
			return 0;
		}
	}
	
	public <E> double getWordDistanceAll(String word1, String word2,
			String type) throws IOException {
	

		
		//JiangAndConrath wup=ws.getJiangAndConrath();
		

		// TreeMap<String, Double> scores1 = jcn.jcn("apple", "banana", "n"); //
		// all
		
		//double similarityValue = wup.max(word1, word2, type);
		double wordsimilarityValue = wup.max(word1.toString(),word2.toString(),type);
		double worddistanceValue=1-wordsimilarityValue;
		java.text.DecimalFormat df=new   java.text.DecimalFormat("#0.00");
		double distacneValue= Double.parseDouble(df.format(worddistanceValue*100));
		return distacneValue;
	}
	
	
	

	public static HashMap<Integer, String> getWordGloss(String keyword,
			String type) throws IOException {
		HashMap<Integer, String> glossMap = new HashMap<Integer, String>();
		POS postype = null;

		String wordtype = null;
		if (type.equalsIgnoreCase("n")) {
			postype = POS.NOUN;
			wordtype = "NOUN";
		} else if (type.equalsIgnoreCase("v")) {
			postype = POS.VERB;
			wordtype = "VERB";
		} else if (type.equalsIgnoreCase("a")) {
			postype = POS.ADJECTIVE;
			wordtype = "ADJECTIVE";
		} else if (type.equalsIgnoreCase("r")) {
			postype = POS.ADVERB;
			wordtype = "ADVERB";
		}

		String path = "WordNet/3.0" + File.separator + "dict";
	//	String path = "D:/WordNet-3.0" + File.separator + "dict";
		
		URL url = new URL("file", null, path);

		IDictionary dict = new Dictionary(url);
		dict.open();

		IIndexWord idxWord = dict.getIndexWord(keyword, postype);

		IWordID wordID = null;

		for (int i = 0;; i++) {
			try {
				wordID = idxWord.getWordIDs().get(i);
				IWord word = dict.getWord(wordID);
				glossMap.put(i, word.getSynset().getGloss());
			} catch (ArrayIndexOutOfBoundsException e) {
				break;
			}

		}
		return glossMap;
	}

}
